/*
    An Observer for NiseRingo.app, This program reboots it when it crashes.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#import "NROObserver.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#define NISERINGO_OBJECT_DIR "NiseRingo.app/Contents/MacOS"
#define NISERINGO_OBJECT_NAME "NiseRingo"

@implementation NROObserver

-init
{
    return [super init];
}

-(void)thread_main:(id)dummy
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    NSString *object_dir,*object_exec_command;
    const char *object_dir_cstr,*object_exec_command_cstr; // forkqvZXNSStrinĝ͏sB
    
    // Uьst@Cւ̃pX擾
    object_dir = [NSString stringWithFormat:@"%@/%s",[[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent],NISERINGO_OBJECT_DIR];
    object_dir_cstr = [object_dir cString];
    
    // ./NiseRingo𐶐
    object_exec_command = [NSString stringWithFormat:@"./%s",NISERINGO_OBJECT_NAME];
    object_exec_command_cstr = [object_exec_command cString];
    
    while (true)
    {
	int status;
	
	if (fork() == 0)
	{
	    // qvZXB
	    // JgfBNgobject_dir_cstrɐݒ肵AexeclŎgUьvZXƒuċNB
	    chdir(object_dir_cstr);
	    execl(object_exec_command_cstr,NISERINGO_OBJECT_NAME,NULL);
	    
	    // ԂĂG[ĂB
	    NSLog([NSString stringWithFormat:@"execl error: %s",strerror(errno)]);
	    exit(-1);
	}
	wait(&status);
	if (WIFEXITED(status)) // Iꍇ
	{
	    NSLog(@"NiseRingo exited as status 0");
	    [[NSApplication sharedApplication] terminate:NULL]; // AvP[VI
	    break;
	}
	else
	{
	    NSLog([NSString stringWithFormat:@"NiseRingo exited as status %d  *** IT WILL BE REBOOTED ***",WEXITSTATUS(status)]);
	}
    }
    
    [pool release];
}

@end
